# tfsummaryvis

> Visualise textual Tensorflow summaries as a directed graph.

Tensorflow summaries are invaluable to understand how a model is put together. They usually look like this:

```
Model: "sequential"
_________________________________________________________________
 Layer (type)                Output Shape              Param #   
=================================================================
 bidirectional (Bidirectiona  (None, 100, 256)         336896    
 l)                                                              
                                                                 
 bidirectional_1 (Bidirectio  (None, 256)              394240    
 nal)                                                            
                                                                 
 dense (Dense)               (None, 2)                 514       
                                                                 
=================================================================
Total params: 731,650
Trainable params: 731,650
Non-trainable params: 0
_________________________________________________________________
```

Pretty easy to understand, right? But what about [this monster](./samples/deeplabv3%2B.txt)? Or [this one](mono-failure.txt) (this one doesn't actually work, do not implement at home)?

Larger models (and those aren't just a simple stack of layers) can be a nightmare to understand - even with a summary - hence this project was born :-)

It converts the above textual tensorflow summary into a directed graph with [nomnoml](https://nomnoml.com).

## Demo
Try the demo here: <https://starbeamrainbowlabs.com/labs/tfsummaryvis/>


## Getting started
If you want to run this project locally, first start by cloning the repository:

```bash
git clone https://git.starbeamrainbowlabs.com/sbrl/tfsummaryvis.git
cd tfsummaryvis;
```

Then, install dependencies:

```bash
npm install
```

Next, build the client-side app:

```bash
npm run build
```

Finally, serve with your [favourite static web server](https://gist.github.com/willurd/5720255):

```bash
npx serve dist/
```


## Contributing
Contributions are very welcome - both issues and pull requests! Please mention in your pull request that you release your work under the MPL-2.0 (see below).

If you're feeling that way inclined, the sponsor button at the top of the page (if you're on GitHub) will take you to my [Liberapay profile](https://liberapay.com/sbrl) if you'd like to donate to say an extra thank you :-)


## License
tfsummaryvis is released under the Mozilla Public License 2.0. The full license text is included in the `LICENSE` file in this repository. Tldr legal have a [great summary](https://tldrlegal.com/license/mozilla-public-license-2.0-(mpl-2)) of the license if you're interested.
